unit u_ecftc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Forms, TAGraph, TASeries, LazUTF8, u_data;

var
 //Коэффициенты для данных контроллера двигателя
 dsk: single;
 dsb: integer;
 //Данные для чтения исходных файлов
 ldp,sdp,hsg,hsc,fcg,fgg,fgv,fgvb: integer;
 //Исходные данные контроллера двигателя
 CPoints: cardinal;
 CGiri: array [0..MAX_POINTS] of word;
 CLT, CST: array [0..MAX_POINTS] of single;

//Запуск расчёта по данным контроллера двигателя
procedure ecc_run;
//Процедура запуска расчёта по данным двух контроллеров
procedure ec_run;
//Проверка файла данных
procedure ec_checkfile(FileName: String);
//Загрузка данных
procedure ec_load_data;
//Автоматический подбор коэффициентов
procedure ec_auto_sync;
//Вывод графиков оборотов
procedure ec_build_graph;
//Расчёт таблицы коррекций
procedure ec_calc;

implementation

uses f_main;

procedure ecc_run;
var
 f: textfile;
 n,i,x,y,k: integer;
 co, cl, cs, cv, cc: byte;
 hf: boolean;
 s,t: string;
 vg,Sum: single;
 sc: char;
begin
 WriteLog('Расчёт по коррекциям контроллера двигателя...');
 GPoints:=0;
 BPoints:=0;
 FileMode:=0;
 {$I-}
 for i:=0 to (MainForm.files_list.Count-1) do
  begin
   hf:=False;
   assignfile(f,UTF8toSys(MainForm.files_list.Items.Strings[i]));
   reset(f);
   if (IOResult<>0) then
    begin
     Writelog('Ошибка доступа к файлу '+MainForm.files_list.Items.Strings[i]);
     continue;
    end;
   for x:=0 to 8 do
    begin
     if eof(f) then break;
     co:=0; cl:=0; cs:=0; cv:=0;
     readln(f,s);
     sc:=';';
     SplitString(s,sc);
     if (SplitN<3) then begin sc:=','; SplitString(s,sc); end;
     if (SplitN>2) then
      for n:=0 to (SplitN-1) do
       begin
        t:=uppercase(SplitA[n]);
        if (pos('RPM',t)>0) then co:=n; //Обороты
        if (pos('LFT',t)>0) then cl:=n;
        if (pos('LONG',t)>0) and ((pos('FT',t)>0) or (pos('TRIM',t)>0)) then cl:=n; //LTFT
        if ((pos('SHRT',t)>0) or (pos('FUEL',t)>0) or (pos('SHORT',t)>0)) and
         ((pos('FT',t)>0) or (pos('TRIM',t)>0)) then cs:=n; //STFT
        if (pos('FUEL',t)>0) and ((pos('PW',t)>0) or (pos('POW',t)>0)) or
         (pos('TIME CORR',t)>0) then cv:=n; //Впрыск
       end;
     if (co>0) and (cs>0) and (cv>0) then
      begin
       hf:=true;
       break;
      end;
    end;
   if not hf then
    begin
     closefile(f);
     IOResult;
     Writelog('Подходящих данных не найдено в файле '+MainForm.files_list.Items.Strings[i]);
     continue;
    end else Writelog('Загрузка "'+MainForm.files_list.Items.Strings[i]+'" ('+
     inttostr(co)+' '+inttostr(cl)+' '+inttostr(cs)+' '+inttostr(cv)+')...');
   cc:=co;
   if (cl>cc) then cc:=cl;
   if (cs>cc) then cc:=cs;
   if (cv>cc) then cc:=cv;
   while not eof(f) do
    begin
     readln(f,s);
     SplitString(s, sc);
     if (SplitN >= cc) then
      begin
       vg:=toDouble(SplitA[cv]);
       if (vg >= (VP[0]-dvm)) and (GPoints < MAX_POINTS) then
        begin
         GMap[GPoints]:=vg;
         if (cl>0) then GBenz[GPoints]:=todouble(SplitA[cl]) else
          GBenz[GPoints]:=0;
         GGaz[GPoints]:=todouble(SplitA[cs]);
         GGiri[GPoints]:=toint(SplitA[co]);
         inc(GPoints);
        end;
      end;
     if (IOResult<>0) then break;
    end;
   closefile(f);
  end;
 {$I+}
 FileMode:=2;
 if (GPoints = MAX_POINTS) then s:=' (!максимум!)' else s:='';
 Writelog('Загружено записей движения: '+inttostr(GPoints)+s);
 if (GPoints<3) then ErrorMessage('Недостаточно данных!');
 if ProcessError then exit;
 Writelog('Построение таблицы...');
 MainForm.t_kmap.Show;
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    k:=0;
    Sum:=0;
    for n:=0 to GPoints-1 do
     begin
      if (GMap[n] >= VP[y]-dvm) and (GMap[n] <= VP[y]+dvp) and
       (GGiri[n] >= OB[x]-dom) and (GGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+GGaz[n]+GBenz[n];
         inc(k);
        end;
     end;
    if (k>0) then MainForm.g_kor.Cells[x+1,y+1] :=
     FloatToStrF(Sum/k,ffFixed, 1, 1) else MainForm.g_kor.Cells[x+1,y+1]:='-';
   end;
end;

procedure ec_checkfile(FileName: String);
var
 f: textfile;
 n,x,co,cg,cb: integer;
 s,t: string;
begin
 if (fgg>-1) and (fcg>-1) then exit;
 FileMode:=0;
 {$I-}
 assignfile(f, FileName);
 reset(f);
 if (IOResult<>0) then exit;
 //Проверка по первым строкам
 for n:=0 to 8 do
  begin
   readln(f,s);
   if (length(s)<10) then continue;
   co:=-1; cg:=-1; cb:=-1;
   SplitString(s,chr(9) {Tab});
   if (SplitN>2) then
    for x:=0 to (SplitN-1) do
     begin
      t:=uppercase(SplitA[x]);
      if (t = 'GIRI') then co:=x;
      if (t = 'GAS') or (t = 'INJ.') or (t = 'INJ,') then cg:=x;
      if (t = 'BENZ') or (t = 'INJ.BNZ') or (t = 'INJ,BNZ') then cb:=x;
     end;
   if (co>-1) and (cg>-1) and (cb>-1) then
    begin
     if (fgg>-1) then break;
     hsg:=n;
     fgg:=co;
     fgv:=cg;
     fgvb:=cb;
     MainForm.file_gas.Caption:=FileName;
     Writelog('Определён файл данных газового контроллера:');
     Writelog(FileName);
     break;
    end;
   co:=-1; cb:=-1;
   SplitString(s,',');
   if (SplitN<3) then SplitString(s,';');
   if (SplitN>2) then
    for x:=0 to (SplitN-1) do
     begin
      t:=uppercase(SplitA[x]);
      if (pos('RPM',t)>0) then co:=x;
      if (pos('FUEL',t)>0) and (pos('TRIM',t)>0) then cb:=x;
      if (pos('SHRTFT',t)>0) or (pos('LONGFT',t)>0) or
       (pos('LFT',t)>0) or (pos('LTFT',t)>0) then cb:=x;
     end;
   if (co>-1) and (cb>-1) then
    begin
     if (fcg>-1) then break;
     hsc:=n;
     fcg:=co;
     MainForm.ltft_list.Clear;
     MainForm.stft_list.Clear;
     MainForm.ltft_list.Items.Add('Отключено');
     for x:=0 to (SplitN-1) do
      begin
       t:=uppercase(SplitA[x]);
       if (pos('FUEL',t)=0) or (pos('TRIM',t)=0) then
        if (pos('FT',t)=0) then continue;
       if (pos('LONG',t)>0) or ((pos('LT',t)>0) and (pos('ELT',t)=0)) then
        MainForm.ltft_list.Items.Add(SplitA[x]) else
         MainForm.stft_list.Items.Add(SplitA[x]);
      end;
     if (MainForm.ltft_list.Items.Count>1) then MainForm.ltft_list.ItemIndex:=1
      else MainForm.ltft_list.ItemIndex:=0;
     if (MainForm.stft_list.Items.Count>0) then MainForm.stft_list.ItemIndex:=0;
     MainForm.file_cont.Caption:=FileName;
     Writelog('Определён файл данных контроллера двигателя:');
     Writelog(FileName);
     break;
    end;
  end;
 closefile(f);
 {$I+}
 FileMode:=1;
end;

procedure ec_load_data;
var
 n: integer;
 f: textfile;
 s: string;
 cc: byte;
 spl: char;
begin
 if (fgg<0) or (fcg<0) then
  begin
   ErrorMessage('Не определены все необходимые исходные данные.');
   exit;
  end;
 FileMode:=0;
 {$I-}
 assignfile(f,MainForm.file_gas.Caption);
 reset(f);
 if (IOResult<>0) then
  begin
   ErrorMessage('Ошибка доступа к файлу данных газового контроллера.');
   exit;
  end;
 GPoints:=0;
 for n:=0 to hsg do if not eof(f) then readln(f,s);
 if eof(f) then
  begin
   ErrorMessage('Ошибка чтения файла данных газового контроллера.');
   exit;
  end;
 cc:=fgg;
 if (fgv>cc) then cc:=fgv;
 if (fgvb>cc) then cc:=fgvb;
 Writelog('Загрузка: '+MainForm.file_gas.Caption+' ('+inttostr(fgg)+' '+
  inttostr(fgv)+' '+inttostr(fgvb)+')...');
 while not eof(f) do
  begin
   readln(f,s);
   SplitString(s, chr(9));
   if (SPlitN >= cc) then
    begin
     if (GPoints < MAX_POINTS) then
      begin
       GGaz[GPoints]:=todouble(SplitA[fgv]);
       GBenz[GPoints]:=todouble(SplitA[fgvb]);
       GGiri[GPoints]:=toint(SplitA[fgg]);
       inc(GPoints);
      end;
    end;
   if (IOResult<>0) then break;
  end;
 closefile(f);
 assignfile(f,MainForm.file_cont.Caption);
 reset(f);
 if (IOResult<>0) then
  begin
   ErrorMessage('Ошибка доступа к файлу данных контроллера двигателя.');
   exit;
  end;
 CPoints:=0;
 for n:=0 to hsc do if not eof(f) then readln(f,s);
 if eof(f) then
  begin
   ErrorMessage('Ошибка чтения файла данных контроллера двигателя.');
   exit;
  end;
 spl:=',';
 SplitString(s,spl);
 if (SplitN<3) then begin  spl:=';'; SplitString(s,spl); end;
 if (SplitN<3) then
  begin
   ErrorMessage('Ошибка чтения заголовка файла данных контроллера двигателя.');
   exit;
  end;
 ldp:=-1; sdp:=-1;
 for n:=0 to (SplitN-1) do
  begin
   if (MainForm.ltft_list.Caption = SplitA[n]) then ldp:=n;
   if (MainForm.stft_list.Caption = SplitA[n]) then sdp:=n;
  end;
 if (sdp<0) then
  begin
   ErrorMessage('Ошибка данных STFT контроллера двигателя.');
   exit;
  end;
 Writelog('Загрузка: '+MainForm.file_cont.Caption+' ('+inttostr(ldp)+' '+
  inttostr(sdp)+' '+inttostr(fcg)+')...');
 if (ldp>-1) then cc:=ldp else cc:=0;
 if (sdp>cc) then cc:=sdp;
 if (fcg>cc) then cc:=fcg;
 while not eof(f) do
  begin
   readln(f,s);
   SplitString(s, spl);
   if (SPlitN >= cc) then
    begin
     if (CPoints < MAX_POINTS) then
      begin
       CGiri[CPoints]:=round(toDouble(SplitA[fcg]));
       CST[CPoints]:=toDouble(SplitA[sdp]);
       if (ldp<0) then CLT[CPoints]:=0 else
        CLT[CPoints]:=toDouble(SplitA[ldp]);
       inc(CPoints);
      end;
    end;
   if (IOResult<>0) then break;
  end;
 closefile(f);
 {$I+}
 FileMode:=1;
 WriteLog('Записей газового контроллера: '+inttostr(GPoints));
 WriteLog('Записей контроллера двигателя: '+inttostr(CPoints));
end;

procedure ec_auto_sync;
var
 n,i,x: integer;
 sum,sk,rk,rs,ck: single;
 rb,cb: integer;
begin
 rb:=toint(MainForm.ds_b_text.Text);
 rk:=toDouble(MainForm.ds_k_text.Text);
 if (rb<>0) or (rk<0.99) or (rk>1.01) then exit;
 if (CPoints<50) or (GPoints<110) then
  begin
   ErrorMessage('Недостаточно данных!');
   exit;
  end;
 WriteLog('Подбор коэффициентов синхронизации данных. Подождите...');
 sk:=GPoints / CPoints;
 rk:=sk; rb:=-50; rs:=999999;
 for cb:=-50 to 50 do
  for x:=-50 to 50 do
   begin
    ck:=x/100 + sk;
    Sum:=0;
    for n:=0 to CPoints-1 do
     begin
      i:=round(ck*n) + cb;
      if (i<0) then i:=0;
      if (i>GPoints-1) then i:=GPoints-1;
      Sum:=Sum + abs(CGiri[n]-GGiri[i]);
     end;
    Sum:=Sum / CPoints;
    if (sum<rs) then begin rs:=sum; rk:=ck; rb:=cb; end;
   end;
 MainForm.ds_b_text.Text:=inttostr(rb);
 MainForm.ds_k_text.Text:=FloatToStrF(rk,ffFixed, 1, 2);
end;

procedure ec_build_graph;
var
 BSer, GSer: TSerie;
 n,i: integer;
 rs: single;
begin
 MainForm.ds_chart.Series.Clear;
 dsk:=toDouble(MainForm.ds_k_text.Text);
 dsb:=toInt(MainForm.ds_b_text.Text);
 BSer:=TSerie.Create(MainForm.ds_chart);
 GSer:=TSerie.Create(MainForm.ds_chart);
 BSer.SeriesColor:=clRed;
 GSer.SeriesColor:=clBlue;
 MainForm.ds_chart.AddSeries(BSer);
 MainForm.ds_chart.AddSeries(GSer);
 rs:=0;
 for n:=0 to CPoints-1 do
  begin
   i:=round(dsk*n)+dsb;
   if (i<0) then i:=0;
   if (i>GPoints-1) then i:=GPoints-1;
   BSer.AddXY(n,CGiri[n],'',clRed);
   GSer.AddXY(n,GGiri[i],'',clBlue);
   rs:=rs + abs(CGiri[n]-GGiri[i]);
  end;
 rs:=rs / CPoints;
 Writelog('Коэффициенты: K = '+FloatToStrF(dsk,ffFixed, 1, 2) + '   B = ' +
  inttostr(dsb)+'.   Средняя разность оборотов: '+FloatToStrF(rs,ffFixed, 1, 2));
 if (rs>200) then if (rs>dom) or (rs>dop) then ErrorMessage('Данные не синхронизированы!');
end;

procedure ec_calc;
var
 x,y,k,i,n:integer;
 Sum: double;
begin
 MainForm.t_kmap.Show;
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    k:=0;
    Sum:=0;
    for n:=0 to CPoints-1 do
     begin
      i:=round(dsk*n)+dsb;
      if (i<0) then i:=0;
      if (i>GPoints-1) then i:=GPoints-1;
      if (GBenz[i] >= VP[y]-dvm) and (GBenz[i] <= VP[y]+dvp) and
       (CGiri[n] >= OB[x]-dom) and (CGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+CLT[n]+CST[n];
         inc(k);
        end;
     end;
    if (k>1) then MainForm.g_kor.Cells[x+1,y+1] :=
     FloatToStrF(Sum/k,ffFixed, 1, 1) else MainForm.g_kor.Cells[x+1,y+1]:='-';
   end;
end;

procedure ec_run;
begin
 dsk:=toDouble(MainForm.ds_k_text.Text);
 WriteLog('Расчёт по данным двух контроллеров...');
 if (dsk<=0) then ErrorMessage('Задан некорректный коэффициент "К" !');
 if ProcessError then exit;
 ec_load_data;
 if ProcessError then exit;
 ec_auto_sync;
 ec_build_graph;
 if ProcessError then exit;
 ec_calc;
end;

end.

