unit u_loader;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LazUTF8, Forms, u_data;

const
 {$IFDEF WINDOWS}
 DIR_SPLITTER = '\';
 {$ELSE}
 DIR_SPLITTER = '/';
 {$ENDIF}

//Подготовка входных данных
procedure SetupData(PE: boolean);
//Загрузка данных из файлов
procedure LoadData;
//Сохранение файла настроек
procedure SaveCfg;
//Загрузка файла настроек
procedure LoadCfg;

implementation

uses f_main;

procedure SetupData(PE: boolean);
var
 n,i,x: integer;
 s: string;
begin
 with MainForm do
  begin
   po_count:=0;
   pv_count:=0;
   for n:=0 to (l_vprysk.Lines.Count - 1) do
    begin
     VP[pv_count] := todouble (l_vprysk.Lines.Strings[n]);
     if (VP[pv_count] > 0) then
      begin
       if (pv_count < 255) then inc(pv_count) else
        break;
      end;
    end;
   s:='';
   for n:=0 to (pv_count-1) do
    s:=s+FloatToStrF(VP[n] ,ffFixed, 2, 1)+' ';
   WriteLog('Точки времени впрыска: '+s);
   for n:=0 to (pv_count-2) do
    if (VP[n] > VP[n+1]) and PE then
     begin
      ErrorMessage('Ошибка в данных времени впрыска!');
      exit;
     end;
   if (pv_count<2) and PE then
    begin
     ErrorMessage('Слишком мало точек времени впрыска.');
     exit;
    end;
   n:=toint(ob_min.Text);
   i:=toint(ob_max.Text);
   x:=toint(ob_step.Text);
   if (n<1) then n:=1;
   if (i>10000) then i:=10000;
   if (x<1) then x:=1;
   OB[0]:=n;
   po_count:=1;
   if PE and ((n>i) or (n<100)) then
    begin
     ErrorMessage('Ошибка настройки оборотов!');
     exit;
    end;
   s:=inttostr(n)+' ';
   while (n < i) do
    begin
     n:=n+x;
     OB[po_count]:=n;
     if (po_count = 255) then break else inc(po_count);
     s:=s+inttostr(n)+' ';
    end;
   if PE then WriteLog('Точки оборотов: '+s);
   dvm:=todouble(dm_vprysk.Text);
   dvp:=todouble(dp_vprysk.Text);
   dmm:=todouble(dm_map.Text);
   dmp:=todouble(dp_map.Text);
   dom:=toint(dm_oboroty.Text);
   dop:=toint(dp_oboroty.Text);
   g_kor.Clear;
   g_benz.Clear;
   g_gaz.Clear;
   g_kor.ColCount:=po_count+1;
   g_kor.RowCount:=pv_count+1;
   g_benz.ColCount:=po_count+1;
   g_benz.RowCount:=pv_count+1;
   g_gaz.ColCount:=po_count+1;
   g_gaz.RowCount:=pv_count+1;
   g_kor.Cells[0,0]:='[Меню]';
   for n:=1 to pv_count do
    begin
     g_kor.Cells[0,n]:=FloatToStrF(VP[n-1] ,ffFixed, 2, 1);
     g_benz.Cells[0,n]:=g_kor.Cells[0,n];
     g_gaz.Cells[0,n]:=g_kor.Cells[0,n];
    end;
   for n:=1 to po_count do
    begin
     g_kor.Cells[n,0]:=inttostr(OB[n-1]);
     g_benz.Cells[n,0]:=g_kor.Cells[n,0];
     g_gaz.Cells[n,0]:=g_kor.Cells[n,0];
    end;
  end;
end;

//Загрузка данных из файлов
procedure LoadData;
var
 f: textfile;
 n,i,x: integer;
 co, cm, cb, cg, cc: byte;
 hf: boolean;
 s,t: string;
 vg: single;
begin
 GPoints:=0;
 BPoints:=0;
 FileMode:=0;
 {$I-}
 for i:=0 to (MainForm.files_list.Count-1) do
  begin
   hf:=False;
   assignfile(f,UTF8toSys(MainForm.files_list.Items.Strings[i]));
   reset(f);
   if (IOResult<>0) then
    begin
     Writelog('Ошибка доступа к файлу '+MainForm.files_list.Items.Strings[i]);
     continue;
    end;
   for x:=0 to 3 do
    begin
     if eof(f) then break;
     cc:=0; co:=0; cm:=0; cb:=0; cg:=0;
     readln(f,s);
     SplitString(s,chr(9) {Tab});
     // Если прочитанная строка бъётся больше чем на 3 столбца,
     // то ищем в ней позиции нужных нам колонок
     if (SplitN>3) then
      for n:=0 to (SplitN-1) do
       begin
        t:=uppercase(SplitA[n]);
        if (t = 'GIRI') then co:=n; //Обороты
        if (t = 'GAS') or (t = 'INJ.') or (t = 'INJ,') then cg:=n; //Впрыск газа
        if (t = 'BENZ') or (t = 'INJ.BNZ') or (t = 'INJ,BNZ') then cb:=n; //Впрыск бензина
        if (t = 'MAP') then cm:=n;
       end;
     //Если всё найдено, то считаем, что заголовок файла найден
     if (co>0) and (cg>0) and (cb>0) and (cm>0) then
      begin
       hf:=true;
       break;
      end;
    end;
   if not hf then
    begin
     closefile(f);
     IOResult;
     Writelog('Не найдено данных в файле '+MainForm.files_list.Items.Strings[i]);
     continue;
    end else Writelog('Загрузка "'+MainForm.files_list.Items.Strings[i]+'" ('+
     inttostr(co)+' '+inttostr(cg)+' '+inttostr(cb)+' '+inttostr(cm)+')...');
   // Определяем последний столбец, чтобы потом отсекать строки
   // с меньшим количеством данных.
   cc:=co;
   if (cg>cc) then cc:=cg;
   if (cb>cc) then cc:=cb;
   if (cm>cc) then cc:=cm;
   while not eof(f) do
    begin
     readln(f,s);
     SplitString(s, chr(9));
     if (SplitN >= cc) then
      begin
       //Пропускаем строки, где не было бензинового впрыска
       if (todouble(SplitA[cb]) = 0) then continue;
       vg:=toDouble(SplitA[cg]);
       // Если впрыск газа равен нулю, то считаем строку как бензиновую,
       // иначе - газовую. Учитываем предельно допустимое количество строк.
       if (vg = 0) and (BPoints < MAX_POINTS) then
        begin
         BBenz[BPoints]:=todouble(SplitA[cb]);
         BGiri[BPoints]:=toint(SplitA[co]);
         BMap[BPoints]:=todouble(SplitA[cm]);
         inc(BPoints);
        end else
         if (GPoints < MAX_POINTS) then
          begin
           GGaz[GPoints]:=vg;
           GBenz[GPoints]:=todouble(SplitA[cb]);
           GGiri[GPoints]:=toint(SplitA[co]);
           GMap[GPoints]:=todouble(SplitA[cm]);
           inc(GPoints);
          end;
      end;
     if (IOResult<>0) then break;
    end;
   closefile(f);
  end;
 {$I+}
 FileMode:=2;
 if (BPoints = MAX_POINTS) then s:=' (!максимум!)' else s:='';
 Writelog('Записей движения на бензине: '+inttostr(BPoints)+s);
 if (GPoints = MAX_POINTS) then s:=' (!максимум!)' else s:='';
 Writelog('Записей движения на газе: '+inttostr(GPoints)+s);
 if (GPoints < 2) or (BPoints < 2) then ErrorMessage('Недостаточно данных!');
 if ProcessError then exit;
 i:=0;
 for n:=0 to BPoints-1 do
  if (BMap[n] > 0) then inc(i);
 if (i<2) then ErrorMessage('Нет данных MAP для бензина!');
 i:=0;
 for n:=0 to GPoints-1 do
  if (GMap[n] > 0) then inc(i);
 if (i<2) then ErrorMessage('Нет данных MAP для газа!');
 i:=0;
 for n:=0 to GPoints-1 do
  if (GMap[n]>3) then
   begin
    GMap[n]:=GMap[n] / 1000;
    inc(i);
   end;
 for n:=0 to BPoints-1 do
  if (BMap[n]>1) then
   begin
    BMap[n]:=BMap[n] / 1000;
    inc(i);
   end;
 if (i>0) then
  writelog('Данные MAP нормализованы для '+inttostr(i)+' из '+
   inttostr(GPoints+BPoints)+' точек.');
end;

procedure SaveCfg;
var
 str: TMemoryStream;
 s: TStringStream;
 hdr: array [0..4] of char;
 b: byte;
 n,i,l: integer;
begin
 try
  str:= TMemoryStream.Create;
  s:= TStringStream.Create('');
  hdr:='BCFG2';
  if (str.Write(hdr,5) <> 5) then exit;
  n:=toint(MainForm.ob_min.Text);
  if (str.Write(n,4) <> 4) then exit;
  n:=toint(MainForm.ob_max.Text);
  if (str.Write(n,4) <> 4) then exit;
  n:=toint(MainForm.ob_step.Text);
  if (str.Write(n,4) <> 4) then exit;
  if (str.Write(dvm,4) <> 4) then exit;
  if (str.Write(dvp,4) <> 4) then exit;
  if (str.Write(dmm,4) <> 4) then exit;
  if (str.Write(dmp,4) <> 4) then exit;
  b:=MainForm.alg_select.ItemIndex;
  if (str.Write(b,1) <> 1) then exit;
  if (str.Write(dom,2) <> 2) then exit;
  if (str.Write(dop,2) <> 2) then exit;
  b:=MainForm.s_vprysk.ItemIndex;
  if (str.Write(b,1) <> 1) then exit;
  if (b=0) then
   begin
    if (str.Write(pv_count,1) <> 1) then exit;
    if (str.Write(VP, pv_count*4) <> pv_count*4) then exit;
   end;
  n:=MainForm.files_list.Count;
  if (str.Write(n,4) <> 4) then exit;
  if (n>0) then
   for i:=0 to n-1 do
    begin
     l:=length(MainForm.files_list.Items.Strings[i]);
     if (str.Write(l,4) <> 4) then exit;
     if (l<1) then continue;
     s.Size:=l;
     s.Seek(0,0);
     s.WriteString(MainForm.files_list.Items.Strings[i]);
     s.Seek(0,0);
     if (str.CopyFrom(s,l) <> l) then exit;
    end;
  if (str.Write(MainForm.g_kor.ColCount,4) <> 4) then exit;
  if (str.Write(MainForm.g_kor.RowCount,4) <> 4) then exit;
  for n:=0 to MainForm.g_kor.ColCount-1 do
   for i:=0 to MainForm.g_kor.RowCount-1 do
    begin
     if (n=0) and (i=0) then continue;
     l:=length(MainForm.g_kor.Cells[n,i]);
     if (str.Write(l,4) <> 4) then exit;
     if (l<1) then continue;
     s.Size:=l;
     s.Seek(0,0);
     s.WriteString(MainForm.g_kor.Cells[n,i]);
     s.Seek(0,0);
     if (str.CopyFrom(s,l) <> l) then exit;
    end;
  if (MainForm.WindowState = wsMaximized) then
   begin
    n:=-1024;
    for l:=0 to 3 do str.Write(n,4);
   end else
    begin
     if (str.Write(MainForm.Left,4) <> 4) then exit;
     if (str.Write(MainForm.Top,4) <> 4) then exit;
     if (str.Write(MainForm.Width,4) <> 4) then exit;
     if (str.Write(MainForm.Height,4) <> 4) then exit;
    end;
  str.SaveToFile(CFG_FILE);
 finally str.Free; s.Free; end;
end;

procedure LoadCfg;
var
 g: boolean;
 str: TMemoryStream;
 s: TStringStream;
 hdr: array [0..4] of char;
 b: byte;
 n,x,y,l: integer;
begin
 if not fileexists(CFG_FILE) then exit;
 g:=false;
 str:=TMemoryStream.Create;
 s:=TStringStream.Create('');
 try
  str.LoadFromFile(CFG_FILE);
  if (str.Read(hdr,5) <> 5) then exit;
  if (hdr <> 'BCFG2') then exit;
  if (str.Read(n,4) <> 4) then exit;
  MainForm.ob_min.Text:=inttostr(n);
  if (str.Read(n,4) <> 4) then exit;
  MainForm.ob_max.Text:=inttostr(n);
  if (str.Read(n,4) <> 4) then exit;
  MainForm.ob_step.Text:=inttostr(n);
  if (str.Read(dvm,4) <> 4) then exit;
  if (str.Read(dvp,4) <> 4) then exit;
  if (str.Read(dmm,4) <> 4) then exit;
  if (str.Read(dmp,4) <> 4) then exit;
  if (str.Read(b,1) <> 1) then exit;
  if (b<6) then MainForm.alg_select.ItemIndex := b;
  Application.ProcessMessages;
  MainForm.alg_selectChange(MainForm);
  if (str.Read(dom,2) <> 2) then exit;
  if (str.Read(dop,2) <> 2) then exit;
  MainForm.dm_vprysk.Text:=FloatToStrF(dvm ,ffFixed, 2, 3);
  MainForm.dp_vprysk.Text:=FloatToStrF(dvp ,ffFixed, 2, 3);
  MainForm.dm_map.Text:=FloatToStrF(dmm ,ffFixed, 2, 2);
  MainForm.dp_map.Text:=FloatToStrF(dmp ,ffFixed, 2, 2);
  MainForm.dm_oboroty.Text:=inttostr(dom);
  MainForm.dp_oboroty.Text:=inttostr(dop);
  if (str.Read(b,1) <> 1) then exit;
  MainForm.s_vprysk.ItemIndex:=b;
  if (b=0) then
   begin
    if (str.Read(pv_count,1) <> 1) then exit;
    if (str.Read(VP, pv_count*4) <> pv_count*4) then exit;
    MainForm.l_vprysk.Clear;
    for n:=0 to pv_count-1 do
     MainForm.l_vprysk.Lines.Add(FloatToStrF(VP[n] ,ffFixed, 2, 1));
   end;
  if (str.Read(n,4) <> 4) then exit;
  MainForm.files_list.Clear;
  for x:=0 to n-1 do
    begin
     if (str.Read(l,4) <> 4) then exit;
     if (l<1) then continue;
     s.Size:=l;
     s.Seek(0,0);
     if (s.CopyFrom(str,l) <> l) then exit;
     MainForm.files_list.Items.Add(s.DataString);
    end;
  if (str.Read(x,4) <> 4) then exit;
  if (str.Read(y,4) <> 4) then exit;
  if (x<1) or (y<1) then exit;
  MainForm.g_kor.ColCount:=x;
  MainForm.g_kor.RowCount:=y;
  for x:=0 to MainForm.g_kor.ColCount-1 do
   for y:=0 to MainForm.g_kor.RowCount-1 do
    begin
     if (x=0) and (y=0) then continue;
     if (str.Read(l,4) <> 4) then exit;
     if (l<1) then continue;
     s.Size:=l;
     s.Seek(0,0);
     if (s.CopyFrom(str,l) <> l) then exit;
     s.seek(0,0);
     MainForm.g_kor.Cells[x,y]:=s.DataString;
    end;
  if (str.Read(n,4) <> 4) then exit;
  if (n=-1024) then MainForm.WindowState := wsMaximized else
   begin
    if (n > -32) and (n < Screen.Width - 32) then MainForm.Left:=n;
    if (str.Read(n,4) <> 4) then exit;
    if (n > -32) and (n < Screen.Height - 32) then MainForm.Top:=n;
    if (str.Read(n,4) <> 4) then exit;
    if (n > 639) and (n <= Screen.Width) then MainForm.Width:=n;
    if (str.Read(n,4) <> 4) then exit;
    if (n > 399) and (n <= Screen.Height) then MainForm.Height:=n;
   end;
  g:=true;
 finally
  str.Free;
  s.free;
  if not g then Writelog('Ошибка загрузки файла настроек!');
 end;
end;

end.

