unit u_mapper;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Forms, u_data, u_mnk;

procedure calc_makros;
procedure calc_alg2;
procedure calc_alg3;
procedure calc_alg4;

implementation

uses f_main;

procedure calc_makros;
var
 n,x,y,k: integer;
 Sum, r: double;
begin
 Writelog('Расчёт по оригинальному макросу...');
 Writelog('Дельта впрыска: +'+FloatToStrF(dvp,ffFixed, 1, 3)+' -'+
  FloatToStrF(dvm,ffFixed, 1, 3));
 Writelog('Дельта оборотов: +'+inttostr(dop)+' -'+inttostr(dom));
 Writelog('Дельта MAP: +'+FloatToStrF(dmp,ffFixed, 1, 3)+' -'+
  FloatToStrF(dmm,ffFixed, 1, 3));
 MainForm.t_kmap.Show;
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    k:=0;
    Sum:=0;
    for n:=0 to BPoints-1 do
     begin
      if (BBenz[n] >= VP[y]-dvm) and (BBenz[n] <= VP[y]+dvp) and
       (BGiri[n] >= OB[x]-dom) and (BGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+BMap[n];
         inc(k);
        end;
     end;
    if (k>0) then r := (Sum / k) else r:=0;
    if (k>0) then MainForm.g_benz.Cells[x+1,y+1]:=FloatToStrF(r ,ffFixed, 2, 3)
     else MainForm.g_benz.Cells[x+1,y+1]:='-';
    k:=0;
    Sum:=0;
    //Округляем результат в лучшего соответствия оригинальному скрипту
    r:=round(r*100) / 100;
    if (MainForm.g_benz.Cells[x+1,y+1] <> '-') then
     for n:=0 to GPoints-1 do
      if (GMap[n] >= r-dmm-0.001) and (GMap[n] <= r+dmp+0.001) and
       (GGiri[n] >= OB[x]-dom) and (GGiri[n] <= OB[x]+dop) then
        if (GBenz[n] > 0) then
         begin
          Sum:=Sum + GBenz[n];
          inc(k);
         end;
    if (k>0) then r:=Sum/k else r:=0;
    if (k>0) then MainForm.g_gaz.Cells[x+1,y+1]:=FloatToStrF(r ,ffFixed, 2, 3)
     else MainForm.g_gaz.Cells[x+1,y+1]:='-';
    Sum:=-(VP[y]-r)/VP[y]*100;
    if (MainForm.g_benz.Cells[x+1,y+1]<>'-') and
     (MainForm.g_gaz.Cells[x+1,y+1]<>'-') then
      MainForm.g_kor.Cells[x+1,y+1]:=FloatToStrF(Sum ,ffFixed, 2, 2)
       else MainForm.g_kor.Cells[x+1,y+1]:='-';
   end;
end;

procedure calc_alg2;
var
 n,x,y,k: integer;
 Sum, rb, rg: double;
begin
 Writelog('Расчёт по средним значениям МАР...');
 Writelog('Дельта впрыска: +'+FloatToStrF(dvp,ffFixed, 1, 3)+' -'+
  FloatToStrF(dvm,ffFixed, 1, 3));
 Writelog('Дельта оборотов: +'+inttostr(dop)+' -'+inttostr(dom));
 MainForm.t_kmap.Show;
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    k:=0;
    Sum:=0;
    for n:=0 to BPoints-1 do
     begin
      if (BBenz[n] >= VP[y]-dvm) and (BBenz[n] <= VP[y]+dvp) and
       (BGiri[n] >= OB[x]-dom) and (BGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+BMap[n];
         inc(k);
        end;
     end;
    if (k>0) then rb := (Sum / k) else rb:=0;
    if (k>0) then MainForm.g_benz.Cells[x+1,y+1]:=FloatToStrF(rb ,ffFixed, 2, 3)
     else MainForm.g_benz.Cells[x+1,y+1]:='-';
    k:=0;
    Sum:=0;
    for n:=0 to GPoints-1 do
     begin
      if (GBenz[n] >= VP[y]-dvm) and (GBenz[n] <= VP[y]+dvp) and
       (GGiri[n] >= OB[x]-dom) and (GGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+GMap[n];
         inc(k);
        end;
     end;
    if (k>0) then rg := (Sum / k) else rg:=0;
    if (k>0) then MainForm.g_gaz.Cells[x+1,y+1]:=FloatToStrF(rg ,ffFixed, 2, 3)
     else MainForm.g_gaz.Cells[x+1,y+1]:='-';
    if (rb<>0) and (rg<>0) then Sum:=(rb-rg)/rg*100 else Sum:=0;
    if (Sum<>0) then
     MainForm.g_kor.Cells[x+1,y+1]:=FloatToStrF(Sum ,ffFixed, 2, 2)
      else MainForm.g_kor.Cells[x+1,y+1]:='-';
   end;
end;

procedure calc_alg3;
var
 n,x: integer;
 r: single;
begin
 Writelog('Расчёт методом аппроксимации...');
 Writelog('Фильтр по времени впрыска: '+FloatToStrF(VP[0]-dvm,ffFixed, 1, 2)+' мс');
 Writelog('Дельта оборотов: +'+inttostr(dop)+' -'+inttostr(dom));
 MainForm.t_benzmap.Show;
 Writelog('Расчёт карты бензина...');
 for x:=0 to po_count-1 do
  begin
   //Записываем точки для расчёта функции зависимости МАР от времени впрыска
   //бензина по мероду наименьших квадратов (МНК)
   MNKp:=0;
   for n:=0 to BPoints-1 do
    begin
     if (BGiri[n] < OB[x]-dom) or (BGiri[n] > OB[x]+dop) or
      (BBenz[n] < VP[0]-dvm) then continue; //Учитываем фильтр
     mnkX[MNKp]:=BBenz[n];
     mnkY[MNKp]:=BMap[n];
     inc(MNKp);
    end;
   //Вычисляем функцию
   calc_mnk;
   //Заполняем соответствующую строку оборотов
   for n:=0 to pv_count-1 do
    begin
     r:=func_mnk(VP[n]);
     if (r<=0.001) or (r>1) then MainForm.g_benz.Cells[x+1,n+1]:='-'
      else MainForm.g_benz.Cells[x+1,n+1]:=FloatToStrF(r ,ffFixed, 2, 3);
    end;
  end;
 MainForm.t_kmap.Show;
 Writelog('Расчёт карты газа и изменений...');
 for x:=0 to po_count-1 do
  begin
   //Записываем точки для расчёта функции зависимости времени впрыска бензина
   //при работе на газе от МАР методом МНК
   MNKp:=0;
   for n:=0 to GPoints-1 do
    begin
     if (GGiri[n] < OB[x]-dom) or (GGiri[n] > OB[x]+dop) or
      (GBenz[n] < VP[0]-dvm) then continue; //Учитываем фильтр
     mnkX[MNKp]:=GMap[n];
     mnkY[MNKp]:=GBenz[n];
     inc(MNKp);
    end;
   //Вычисляем функцию
   calc_mnk;
   //Заполняем соответствующую строку оборотов
   for n:=0 to pv_count-1 do
    begin
     if (MainForm.g_benz.Cells[x+1,n+1] = '-') then
      begin
       MainForm.g_gaz.Cells[x+1,n+1]:='-';
       MainForm.g_kor.Cells[x+1,n+1]:='-';
       continue;
      end;
     r:=func_mnk(todouble(MainForm.g_benz.Cells[x+1,n+1]));
     if (r<=0.001){ or (r>VP[pv_count-1])} then
      begin
       MainForm.g_gaz.Cells[x+1,n+1]:='-';
       MainForm.g_kor.Cells[x+1,n+1]:='-';
      end
       else
        begin
         MainForm.g_gaz.Cells[x+1,n+1]:=FloatToStrF(r ,ffFixed, 2, 3);
         MainForm.g_kor.Cells[x+1,n+1]:=
          FloatToStrF(((r-VP[n])/VP[n]*100) ,ffFixed, 2, 2);
        end;
    end;
  end;

 {  if (k>0) then MainForm.g_gaz.Cells[x+1,y+1]:=FloatToStrF(r ,ffFixed, 2, 3)
     else MainForm.g_gaz.Cells[x+1,y+1]:='-';
    Sum:=-(VP[y]-r)/VP[y]*100;
    if (MainForm.g_benz.Cells[x+1,y+1]<>'-') and
     (MainForm.g_gaz.Cells[x+1,y+1]<>'-') then
      MainForm.g_kor.Cells[x+1,y+1]:=FloatToStrF(Sum ,ffFixed, 2, 2)
       else MainForm.g_kor.Cells[x+1,y+1]:='-';
   end;  }
end;

procedure calc_alg4;
var
 n,x,y,k: integer;
 Sum, r, gr, sm: double;
begin
 Writelog('Расчёт по таблице MAP...');
 Writelog('Дельта оборотов: +'+inttostr(dop)+' -'+inttostr(dom));
 Writelog('Дельта MAP: +'+FloatToStrF(dmp,ffFixed, 1, 3)+' -'+
  FloatToStrF(dmm,ffFixed, 1, 3));
 MainForm.t_benzmap.Show;
 Writelog('Построение бензиновой карты MAP...');
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    k:=0;
    Sum:=0;
    for n:=0 to BPoints-1 do
     begin
      if (BBenz[n] >= VP[y]-dvm) and (BBenz[n] <= VP[y]+dvp) and
       (BGiri[n] >= OB[x]-dom) and (BGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+BMap[n];
         inc(k);
        end;
     end;
    if (k>0) then r := (Sum / k) else r:=0;
    if (k>0) then MainForm.g_benz.Cells[x+1,y+1]:=FloatToStrF(r ,ffFixed, 2, 2)
     else MainForm.g_benz.Cells[x+1,y+1]:='-';
   end;
 MainForm.t_kmap.Show;
 Writelog('Рассчёт краты изменений...');
 for x:=0 to po_count-1 do
  for y:=0 to pv_count-1 do
   begin
    Application.ProcessMessages;
    //Получаем МАР текущей точки, если его нет - идём дальше
    sm:=todouble(MainForm.g_benz.Cells[x+1,y+1]);
    if (sm = 0) then
     begin
      MainForm.g_kor.Cells[x+1,y+1]:='-';
      continue;
     end;
    //Считаем среднее время впрыска бензина для текущей точки (MAP, Обороты)
    k:=0;
    Sum:=0;
    for n:=0 to BPoints-1 do
     begin
      if (BMap[n] >= sm-dmm-0.001) and (BMap[n] <= sm+dmp+0.001) and
       (BGiri[n] >= OB[x]-dom) and (BGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+BBenz[n];
         inc(k);
        end;
     end;
    if (k>0) then r := (Sum / k) else r:=0;
    //Считаем среднее время впрыска бензина на газе для текущей точки (MAP, Обороты)
    k:=0;
    Sum:=0;
    for n:=0 to GPoints-1 do
     begin
      if (GMap[n] >= sm-dmm-0.001) and (GMap[n] <= sm+dmp+0.001) and
       (GGiri[n] >= OB[x]-dom) and (GGiri[n] <= OB[x]+dop) then
        begin
         Sum:=Sum+GBenz[n];
         inc(k);
        end;
     end;
    if (k>0) then gr := (Sum / k) else gr:=0;
    if (r>0) and (gr>0) then
     begin
      MainForm.g_gaz.Cells[x+1,y+1]:=FloatToStrF( gr ,ffFixed, 2, 2);
      MainForm.g_kor.Cells[x+1,y+1]:=FloatToStrF( (gr-r)/r*100 ,ffFixed, 2, 2);
     end
      else
       begin
        MainForm.g_kor.Cells[x+1,y+1]:='-';
        MainForm.g_gaz.Cells[x+1,y+1]:='-';
       end;
   end;
end;

end.

